<template>
  <div id="index">
    <el-row>
      <el-col :span="24" class="main animate__animated animate__backInRight">
        <el-col :span="24" class="demand">
          <el-image class="image" :src="demand" fit="fill" />
          <div class="select">
            <el-row class="select_1">
              <el-col class="over" :span="6" v-if="oneList.length > 0">
                <div class="list">
                  <div class="left">技术领域：</div>
                  <div class="right">
                    <div class="label" v-for="(item, index) in oneList" :key="index">
                      {{ item.label }}<el-icon @click="toDel(item, 'one')"><Close /></el-icon>
                    </div>
                  </div>
                </div>
              </el-col>
              <el-col class="over" :span="6" v-if="twoList.length > 0">
                <div class="list">
                  <div class="left">合作方式：</div>
                  <div class="right">
                    <div class="label" v-for="(item, index) in twoList" :key="index">
                      {{ item.label }}<el-icon @click="toDel(item, 'two')"><Close /></el-icon>
                    </div>
                  </div>
                </div>
              </el-col>
              <el-col class="over" :span="6" v-if="thrList.length > 0">
                <div class="list">
                  <div class="left">需求地区：</div>
                  <div class="right">
                    <div class="label" v-for="(item, index) in thrList" :key="index">
                      {{ item.label }}<el-icon @click="toDel(item, 'thr')"><Close /></el-icon>
                    </div>
                  </div>
                </div>
              </el-col>
              <el-col class="over" :span="6" v-if="fourList.length > 0">
                <div class="list">
                  <div class="left">需求状态：</div>
                  <div class="right">
                    <div class="label" v-for="(item, index) in fourList" :key="index">
                      {{ item.label }}<el-icon @click="toDel(item, 'four')"><Close /></el-icon>
                    </div>
                  </div>
                </div>
              </el-col>
            </el-row>
          </div>
        </el-col>
        <div class="w_1200">
          <el-col :span="24" class="one">
            <el-row class="one_1" v-for="(val, indexs) in searchList" :key="indexs">
              <el-col :span="3" class="left">{{ val.title }}</el-col>
              <el-col :span="21" class="right">
                <a-button
                  class="title"
                  v-for="(item, index) in val.list"
                  :key="index"
                  type="link"
                  size="samll"
                  @click="toSelect(val, item)"
                  :class="[item.is_active ? 'show' : '']"
                >
                  {{ item.label }}
                </a-button>
              </el-col>
            </el-row>
          </el-col>
          <el-col :span="24" class="two">
            <el-col
              :span="24"
              class="list"
              v-for="(item, index) in list"
              :key="index"
              @click="toView(item)"
            >
              <el-col :span="24" class="name">
                <el-tooltip effect="dark" :content="item.name" placement="top">
                  {{ item.name || '暂无需求名称' }}
                </el-tooltip>
              </el-col>
              <el-row class="other">
                <el-col :span="8" class="other_1">
                  <span>技术领域：</span>
                  {{ getDict(item.field, 'field') }}
                </el-col>
                <el-col :span="8" class="other_1">
                  <span>需求地区：</span>
                  {{ getArea(item.area) }}
                </el-col>
                <el-col :span="8" class="other_1">
                  <span>单位：</span>
                  {{ item.userName || '暂无单位' }}
                </el-col>
              </el-row>
              <el-col :span="24" class="brief textOver">
                {{ item.brief || '没有更多需求简介' }}
              </el-col>
            </el-col>
          </el-col>
          <el-col :span="24" class="thr">
            <el-pagination
              background
              layout="total, prev, pager, next"
              :page-sizes="[10, 20, 50, 100, 200]"
              :total="total"
              :page-size="limit"
              v-model:current-page="currentPage"
              @current-change="changePage"
              @size-change="sizeChange"
            >
            </el-pagination>
          </el-col>
        </div>
      </el-col>
    </el-row>
  </div>
</template>

<script setup>
const $checkRes = inject('$checkRes')
import { get } from 'lodash-es'
// 接口
import { DemandStore } from '@/store/api/platform/demand'
import { DictDataStore } from '@/store/api/system/dictData'
const store = DemandStore()
const dictDataStore = DictDataStore()
// 图片引入
import demand from '@/assets/innovation.png'
// 路由
const router = useRouter()
// 加载中
const loading = ref(false)
const searchForm = ref({})
// 列表
const list = ref([])
let skip = 0
let limit = inject('limit')
const total = ref(0)
// 字典表
const fieldList = ref([])
const selectList = ref([])
const oneList = ref([])
const twoList = ref([])
const thrList = ref([])
const fourList = ref([])
const searchList = ref([
  {
    title: '技术领域',
    list: [
      { value: '0', label: '全部' },
      { value: '1', label: '先进制造' },
      { value: '2', label: '地球、空间与海洋' },
      { value: '3', label: '新材料' },
      { value: '4', label: '新能源与节能' },
      { value: '5', label: '核应用技术' },
      { value: '6', label: '环境保护' },
      { value: '7', label: '现代交通' },
      { value: '8', label: '现代农业' },
      { value: '9', label: '生物医药与医疗器械' },
      { value: '10', label: '电子信息' },
      { value: '11', label: '航空航天' }
    ]
  },
  {
    title: '合作方式',
    list: [
      { value: '0', label: '全部' },
      { value: '1', label: '技术开发' },
      { value: '2', label: '技术咨询' },
      { value: '3', label: '技术服务' },
      { value: '4', label: '许可转让' },
      { value: '5', label: '完全转让' },
      { value: '6', label: '技术入股' },
      { value: '7', label: '合作开发' },
      { value: '8', label: '其他' }
    ]
  },
  {
    title: '需求地区',
    list: [
      { value: '0', label: '北京市' },
      { value: '1', label: '天津市' },
      { value: '2', label: '河北省' },
      { value: '3', label: '山西省' },
      { value: '4', label: '内蒙古自治区' },
      { value: '5', label: '辽宁省' },
      { value: '6', label: '吉林省' },
      { value: '7', label: '上海市' },
      { value: '8', label: '江苏省' },
      { value: '9', label: '浙江省' },
      { value: '10', label: '安徽省' },
      { value: '11', label: '福建省' },
      { value: '12', label: '江西省' },
      { value: '13', label: '山东省' },
      { value: '14', label: '河南省' },
      { value: '15', label: '湖北省' },
      { value: '16', label: '湖南省' },
      { value: '17', label: '广东省' },
      { value: '18', label: '广西壮族自治区' },
      { value: '19', label: '海南省' },
      { value: '20', label: '重庆市' },
      { value: '21', label: '四川省' },
      { value: '22', label: '贵州省' },
      { value: '23', label: '云南省' }
    ]
  },
  {
    title: '需求状态',
    list: [
      { value: '0', label: '全部' },
      { value: '1', label: '洽谈中' },
      { value: '2', label: '已结束' }
    ]
  }
])
// 查看
const toView = (item) => {
  router.push({ path: '/demand/detail', query: { id: item.id || item._id } })
}
// 请求
onMounted(async () => {
  loading.value = true
  await searchOther()
  await search({ skip, limit })
  loading.value = false
})
const searchOther = async () => {
  let result
  // 技术领域
  result = await dictDataStore.query({ code: 'field', is_use: '0' })
  if ($checkRes(result)) fieldList.value = result.data
}
const search = async (query = { skip: 0, limit }) => {
  const info = {
    skip: query.skip,
    limit: query.limit,
    ...searchForm.value,
    is_use: '0',
    status: '1'
  }
  const res = await store.list(info)
  if (res.errcode == '0') {
    list.value = res.data
    total.value = res.total
  }
}
// 字典数据转换
const getDict = (data, model) => {
  let res
  if (model == 'field') res = fieldList.value.find((f) => f.value == data)
  return get(res, 'label')
}
// 地区显示
const getArea = (data) => {
  if (data) return data.join(',')
  else return '暂无地区'
}
// 选择查询
const toSelect = (data, item) => {
  for (const val of searchList.value) {
    if (val.title == data.title) {
      for (const i of data.list) {
        if (i.value == item.value) {
          i.is_active = true
          const select = selectList.value.find((f) => f.label == i.label)
          if (!select) selectList.value.push({ ...i, ...{ title: val.title } })
        }
      }
    }
  }
  for (const val of selectList.value) {
    if (val.title == '技术领域') {
      const one = oneList.value.find((f) => f.value == val.value)
      if (!one) oneList.value.push(val)
      else oneList.value = oneList.value.filter((f) => f.value == val.value)
    }
    if (val.title == '合作方式') {
      const two = twoList.value.find((f) => f.value == val.value)
      if (!two) twoList.value.push(val)
      else twoList.value = twoList.value.filter((f) => f.value == val.value)
    }
    if (val.title == '需求地区') {
      const thr = thrList.value.find((f) => f.value == val.value)
      if (!thr) thrList.value.push(val)
      else thrList.value = thrList.value.filter((f) => f.value == val.value)
    }
    if (val.title == '需求状态') {
      const four = fourList.value.find((f) => f.value == val.value)
      if (!four) fourList.value.push(val)
      else fourList.value = fourList.value.filter((f) => f.value == val.value)
    }
  }
}
// 删除标签
const toDel = (item, type) => {
  if (type == 'one') {
    const one = oneList.value.filter((f) => f.value != item.value)
    oneList.value = one
    if (item.title == searchList.value[0].title) {
      for (const i of searchList.value[0].list) {
        if (i.value == item.value) i.is_active = !i.is_active
      }
    }
  }
  if (type == 'two') {
    const two = twoList.value.filter((f) => f.value != item.value)
    twoList.value = two
    if (item.title == searchList.value[1].title) {
      for (const i of searchList.value[1].list) {
        if (i.value == item.value) i.is_active = !i.is_active
      }
    }
  }
  if (type == 'thr') {
    const thr = thrList.value.filter((f) => f.value != item.value)
    thrList.value = thr
    if (item.title == searchList.value[2].title) {
      for (const i of searchList.value[2].list) {
        if (i.value == item.value) i.is_active = !i.is_active
      }
    }
  }
  if (type == 'four') {
    const four = fourList.value.filter((f) => f.value != item.value)
    fourList.value = four
    if (item.title == searchList.value[3].title) {
      for (const i of searchList.value[3].list) {
        if (i.value == item.value) i.is_active = !i.is_active
      }
    }
  }
  const select = selectList.value.filter((f) => f.label != item.label)
  selectList.value = select
}
const currentPage = ref(1)
// 分页
const changePage = (page = currentPage.value) => {
  search({ skip: (page - 1) * limit, limit: limit })
}
const sizeChange = (limits) => {
  limit = limits
  currentPage.value = 1
  search({ skip: 0, limit: limit })
}
</script>
<style lang="scss" scoped>
.main {
  background: rgb(248, 248, 248);

  .demand {
    position: relative;
    .image {
      width: 100%;
      height: 200px;
    }
    .select {
      width: 1200px;
      position: absolute;
      left: 20%;
      bottom: 10%;
      .select_1 {
        display: flex;
        align-items: flex-end;
        .over {
          max-height: 106px;
          overflow-y: auto;
          .list {
            border-radius: 5px;
            margin-right: 10px;
            background-color: #fff;
            padding: 5px;
            font-size: 14px;
            .left {
              padding: 10px;
            }
            .right {
              display: flex;
              flex-wrap: wrap;
              .label {
                display: flex;
                align-items: center;
                margin: 3px;
                padding: 5px;
                background: #f5f5f5;
                border: 1px solid #f0f0f0;
                border-radius: 2px;
              }
            }
          }
        }
        .over::-webkit-scrollbar {
          display: none;
        }
      }
    }
  }

  .one {
    background: #ffffff;
    border-radius: 10px;
    padding: 15px;
    margin: 10px 0 0 0;

    .one_1 {
      display: flex;
      align-items: center;
      padding: 10px 0;
      border-bottom: #9d9898 1px dashed;

      .left {
        background: #2280ff;
        border-radius: 15px;
        line-height: 26px;
        color: #fff;
        text-align: center;
        overflow: hidden;
        white-space: nowrap;
        text-overflow: ellipsis;
        font-family: PingFangSC-Medium;
      }

      .right {
        .show {
          color: #2374ff !important;
        }
        .title {
          color: #666;
          font-size: 14px;
          line-height: 15px;
          margin: 0 10px;
          display: inline-block;
          overflow: hidden;
          text-decoration: none;
        }

        .title:hover {
          color: #2374ff;
        }
      }
    }
  }

  .two {
    margin-top: 20px;
    background: #ffffff;
    border-radius: 10px;
    padding: 15px;

    .list {
      margin-bottom: 10px;
      border-bottom: 1px solid #ebebeb;
      padding-bottom: 10px;

      .name {
        color: #337ab7;
        font-size: 18px;
        font-weight: bold;
        display: inline-block;
        margin: 10px 0;
      }

      .name:hover {
        color: #2374ff;
      }

      .other {
        padding: 5px 0;

        .other_1 {
          font-family: 'PingFangSC-Light', 'Microsoft YaHei', 'WenQuanYi Micro Hei', arial,
            sans-serif;
          font-size: 12px;
          font-weight: normal;
        }

        .other_1:hover {
          color: #2374ff;
        }
      }

      .brief {
        line-height: 30px;
        color: #666;
        font-size: 14px;
      }
    }
  }

  .thr {
    display: flex;
    flex-direction: row-reverse;
    padding: 20px;
  }
}
</style>
